<h1>Список задач</h1>
<input type="button" value="Добавить" class="btn btn-light" (click)="add()" />
<h3>Всего в таблице элементов {{jobCount}}</h3>
<table *ngIf="tableMode; else create" class="table table-striped">
    <thead>
        <tr>
            <td>Id</td>
            <td>Заголовок</td>
            <td>Приоритет</td>
            <td>Описание</td>
            <td>UserId</td>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let i of jobs">
            <ng-template [ngIf]="job?.id != i.id" [ngIfElse]="edit">
                <td width="16%">{{i?.id}}</td>
                <td width="16%">{{i?.title}}</td>
                <td width="16%">{{getPriority(i?.preorityNumber)}}</td>
                <td width="16%">{{i?.description}}</td>
                <td width="16%">{{i?.userId}}</td>
                <td width="20%">
                    <button class="btn btn-sm btn-primary" (click)="editJob(i)">Изменить</button>
                    <button class="btn btn-sm btn-danger" (click)="deleteJob(i)">Удалить</button>
                </td>
            </ng-template>
        </tr>
    </tbody>
</table>
<ngb-pagination *ngIf="tableMode" class="d-flex justify-content-center" [collectionSize]="jobCount" [pageSize]="pageSize" [(page)]="page" [boundaryLinks]="true" (pageChange)="onPageChanged($event)"></ngb-pagination>


<!--шаблон для редактирования-->
<ng-template #edit>
    <td>
        <input type="text" disabled [ngModel]="job.id" class="form-control" />
    </td>
    <td>
        <input #title="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="job.title" class="form-control" />
        <div class="alert alert-danger" [hidden]="title.valid || title.pristine">
            Заголовок не может содержать русских букв
        </div>
    </td>
    <td>
        <select class="form-control" [(ngModel)]="job.preorityNumber">
            <option value="1">Низкий</option>
            <option value="2">Средний</option>
            <option value="3">Высокий</option>
        </select>  
    </td>
    <td>
        <input #description="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="job.description" class="form-control" />
        <div class="alert alert-danger" [hidden]="description.valid || description.pristine">
            Описание не может содержать русских букв
        </div>
    </td>
    <td>
        <input #userId="ngModel" required pattern="^[1-9]\d*$" type="text" [(ngModel)]="job.userId" class="form-control" />
        <div class="alert alert-danger" [hidden]="userId.valid || userId.pristine">
            Идентификатор пользователя должен быть натуральным числом
        </div>
    </td>
    <td width="20%">
        <input type="button" [disabled]="!title.valid || !description.valid || !userId.valid" value="Сохранить" (click)="updateJob()" class="btn btn-sm btn-success" />
        <input type="button" value="Отмена" (click)="cancelEditJob()" class="btn btn-sm btn-warning" />
    </td>
</ng-template>

<!--шаблон для добавления-->
<ng-template #create>
    <div class="form-group">
        <label>Заголовок</label>
        <input #title="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="job.title" class="form-control" />
        <div class="alert alert-danger" [hidden]="title.valid || title.pristine">
            Заголовок не может содержать русских букв
        </div>
    </div>
    <div class="form-group">
        <label>Приоритет</label>
        <select class="form-control" [(ngModel)]="job.preorityNumber">
            <option value="1">Низкий</option>
            <option value="2">Средний</option>
            <option value="3">Высокий</option>
        </select> 
    </div>
    <div class="form-group">
        <label>Описание</label>
        <input #description="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="job.description" class="form-control" />
        <div class="alert alert-danger" [hidden]="description.valid || description.pristine">
            Описание не может содержать русских букв
        </div>
    </div>
    <div class="form-group">
        <label>Идентификатор пользователя</label>
        <input #userId="ngModel" required pattern="^[1-9]\d*$" type="text" [(ngModel)]="job.userId" class="form-control" />
        <div class="alert alert-danger" [hidden]="userId.valid || userId.pristine">
            Идентификатор пользователя должен быть натуральным числом
        </div>
    </div>
    <div class="form-group">
        <label>Создать задачу в рамках</label>
        <div class="form-inline">
            <select class="form-control" [(ngModel)]="linkWithEntity">
                <option value="1">Без привязки</option>
                <option value="2">Дневного плана</option>
                <option value="3">Комплексной задачи</option>
            </select>
            <input #linkEntity="ngModel" required pattern="^[1-9]\d*$" [disabled]="linkWithEntity == '1'" type="text" [(ngModel)]="linkEntityId" class="form-control" />
        </div>
        <div class="alert alert-danger" [hidden]="linkEntity.valid || linkEntity.pristine || linkEntity.disabled">
            Идентификатор должен быть натуральным числом
        </div>
    </div>
    <div>
        <input type="button" [disabled]="!title.valid || !description.valid || !userId.valid || !linkEntity.valid && !linkEntity.disabled" value="Сохранить" (click)="addJob()" class="btn btn-success" />
        <input type="button" value="Отмена" (click)="cancelAddJob()" class="btn btn-warning" />
    </div>
</ng-template>